package com.offcn.api.xyzb;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MyDateUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.XYZB;

import net.sf.json.JSONObject;



/**
 * 获取运营信息
 * 
 * @author puhui
 *
 */
public class operation_info extends XYZB implements API {
	public String Description;//参数集合
	public int id;//房间id
	
	
	@Override
	public void initialize(HashMap<String, Object> data) {
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		// 获取parameter对应的内容
		Description = MapUtil.getValue("Description", data);
		if(Description.contains("错误token")){
			Response re = RequestDataUtils.Get_Errtoken(data, Url, Client_token);
			return re;
		}else if(Description.contains("超长token")){
			Response re = RequestDataUtils.Get_Longtoken(data, Url, Client_token);
			return re;
		}else if(Description.contains("无token")){
			Response re = RequestDataUtils.Get_Notoken_NoCookie(data, Url);
			return re;
		}
		Response re = RequestDataUtils.Get_Noparameter(data, Url,Client_token);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		
		JsonPath jp = re.body().jsonPath();
		System.out.println(re.asString());
		
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=StringUtils.decodeUnicode(jp.getString("msg"));
			
			if ((data.get("code") != null )
					&& ((jp.getString("code") == null) || (!jp.getString(
							"code").equals(data.get("code").toString())))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null)
					&& ((msg == null) || (!msg.equals(data.get("msg").toString())))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			if("操作成功".equals(jp.getString("msg"))){
				
				//是否是线上环境
				if (!isProduct) {
					String weixintitle=jp.getString("data.weixintitle");
					
					String weixinlink=jp.getString("data.weixinlink");
					
					String weibotitle=jp.getString("data.weibotitle");
					
					String weibolink=jp.getString("data.weibolink");
					
					String qqgrouptitle=jp.getString("data.qqgrouptitle");
					
					String qqgrouplink=jp.getString("data.qqgrouplink");
					
					String updateTime=jp.getString("data.updateTime");
					
					if(weixinlink!=null){
						weixinlink = MapUtil.killQuotes(weixinlink, "\"");
					}
					if(weibotitle!=null){
						weibotitle = MapUtil.killQuotes(weibotitle, "\"");
					}
					if(weibolink!=null){
						weibolink = MapUtil.killQuotes(weibolink, "\"");
					}
					if(qqgrouptitle!=null){
						qqgrouptitle = MapUtil.killQuotes(qqgrouptitle, "\"");
					}
					if(qqgrouplink!=null){
						qqgrouplink = MapUtil.killQuotes(qqgrouplink, "\"");
					}
					if(updateTime!=null){
						updateTime=updateTime.substring(0,updateTime.length()-2);
					}
					
					try {
						ResultSet xyu_room = this.selectFromDB(
								" xyu_room  r ",
								" r.room_num = '" + Current_room + "' ");
						xyu_room.last();
						
						
						if (!(xyu_room.getString("operation_info")).contains(weixintitle)){
							result = result && false;
							failReason = failReason + "xyu_room info in DB is wrong;";
						} 
						if (!(xyu_room.getString("operation_info")).contains(weixinlink)){
							result = result && false;
							failReason = failReason + "xyu_room info in DB is wrong;";
						} 
						if (!(xyu_room.getString("operation_info")).contains(weibotitle)){
							result = result && false;
							failReason = failReason + "xyu_room info in DB is wrong;";
						} 
						if (!(xyu_room.getString("operation_info")).contains(weibolink)){
							result = result && false;
							failReason = failReason + "xyu_room info in DB is wrong;";
						} 
						if (!(xyu_room.getString("operation_info")).contains(qqgrouptitle)){
							result = result && false;
							failReason = failReason + "xyu_room info in DB is wrong;";
						} 
						if (!(xyu_room.getString("operation_info")).contains(qqgrouplink)){
							result = result && false;
							failReason = failReason + "xyu_room info in DB is wrong;";
						} 
						if (!(xyu_room.getString("operation_info")).contains(updateTime)){
							result = result && false;
							failReason = failReason + "xyu_room info in DB is wrong;";
						} 
						else {
							Log.logInfo("xyu_room info in DB is correct;");
						}
						
					} catch (Exception e) {
						result = result && false;
						failReason = failReason + "cannot verify xyu_room info in DB;";
						e.printStackTrace();
					}
				}
			}
			
			
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
